#include <stdio.h>
#include <stdint.h>

#define N		31

#define BITS		8
#define TYPE		uint8_t

#define LIMBS		((N + BITS - 1) / BITS)
				// N / BITS rounded up
#define LIMB_MAX	((TYPE)-1)

void popcount_all(void)
{
	TYPE j[LIMBS];

	for (int l = 0; l < LIMBS; l++) {
		j[l] = 0;
	}

	while (1) {
		for (int l = 0; l < LIMBS; l++) {
			if (j[l] < LIMB_MAX) {
				j[l] = j[l] + 1;
				break;
			}

			j[l] = 0;

			if (l + 1 >= LIMBS) {
				printf("Overflow\n");
				return;
			}
		}

		for (int l = LIMBS - 1; l >= 0; l--) {
			printf(" %4d", j[l]);
		}

		printf("\n");
	}
}

int main()
{
	popcount_all();
	return 0;
}
